mcrypt_cfb
mcrypt_decrypt
Mcrypt Functions
PHP Manual

# mcrypt_create_iv

(PHP 4, PHP 5)

mcrypt_create_iv — Creates an initialization vector (IV) from a random source

### Description

string mcrypt_create_iv ( int `$size` [, int `$source` = MCRYPT_DEV_RANDOM ] )

Creates an initialization vector (IV) from a random source.

The IV is only meant to give an alternative seed to the encryption routines. This IV does not need to be secret at all, though it can be desirable. You even can send it along with your ciphertext without losing security.

### Parameters

`size`

  The size of the IV.

`source`

  The source of the IV. The source can be `MCRYPT_RAND` (system random number generator), `MCRYPT_DEV_RANDOM` (read data from /dev/random) and `MCRYPT_DEV_URANDOM` (read data from /dev/urandom). Prior to 5.3.0, `MCRYPT_RAND` was the only one supported on Windows.

### Return Values

Returns the initialization vector, or `FALSE` on error.

### Changelog

Version | Description
--- | ---
5.3.0 | `MCRYPT_DEV_RANDOM` and `MCRYPT_DEV_URANDOM` became available on Windows platforms.
5.3.0 | It is no longer required to call srand() first. This is now done automatically.

### Examples

Example #1 mcrypt_create_iv() Example

`<?php
$size = mcrypt_get_iv_size(MCRYPT_CAST_256, MCRYPT_MODE_CFB);
$iv = mcrypt_create_iv($size, MCRYPT_DEV_RANDOM);
?>`

### See Also

- » http://www.ciphersbyritter.com/GLOSSARY.HTM#IV
- » http://www.quadibloc.com/crypto/co0409.htm
- Chapter 9.3 of Applied Cryptography by Schneier (ISBN 0-471-11709-9)

mcrypt_cfb
mcrypt_decrypt
Mcrypt Functions
PHP Manual